#include <stddef.h>

#ifndef an_include

#	define an_include

#	define AN_PAI	3.14159265358979323846

#	define AN_X_MIN_IMAGE_SIZE 16
#	define AN_Y_MIN_IMAGE_SIZE 16
#	define AN_T_MIN_IMAGE_SIZE 2

#	define AN_X_MAX_IMAGE_SIZE 512
#	define AN_Y_MAX_IMAGE_SIZE 512
#	define AN_T_MAX_IMAGE_SIZE 512

	/************************************/

	typedef struct AN_IMAGE_COORD {
		int x ;
		int y ;
		int t ;
	} AN_IMAGE_COORD ;

	typedef struct AN_IMAGE_COORD_3DT {
		int x ;
		int y ;
		int z ;
		int t ;
	} AN_IMAGE_COORD_4D ;

	typedef struct AN_IMAGE_COORD_3D {
		int x ;
		int y ;
		int z ;
	} AN_IMAGE_COORD_3D ;

	typedef struct AN_IMAGE_COORD_2D {
		int x ;
		int y ;
	} AN_IMAGE_COORD_2D ;
	
	typedef struct AN_VECTOR_FF {
		float vx ;
		float vy ;
	} AN_VECTOR_FF ;

	typedef struct AN_VECTOR_3D {
		float x ;
		float y ;
		float z ;
	} AN_VECTOR_3D ;

	typedef struct AN_VECTOR_2D {
		float x ;
		float y ;
	} AN_VECTOR_2D ;

	typedef struct AN_VECTOR_3DT {
		float x ;
		float y ;
		float z ;
		float t ;
	} AN_VECTOR_3DT ;

	typedef struct AN_VECTOR_2DT {
		float x ;
		float y ;
		float t ;
	} AN_VECTOR_2DT ;

	typedef struct AN_VECTOR_2DD {
		double x ;
		double y ;
	} AN_VECTOR_2DD ;

	typedef struct AN_VECTOR_2DTD {
		double x ;
		double y ;
		double t ;
	} AN_VECTOR_2DTD ;

	/*****************************/

	int an_get_img() ;

	void *an_malloc_2D() ;
	void *an_calloc_2D() ;
	void *an_malloc_3D() ;
	void *an_calloc_3D() ;

#endif

